{% from "gerrit/map.jinja" import client with context %}
{%- if client.enabled %}

{%- for account_name, account in client.user.iteritems() %}

{%- if client.get('try_login', False) and account.http_password is defined %}
{#- Try to login. If ldap is enabled, user will be able to login and account will be properly linked
 to ldap entry. If ldap is not enabled, login will fail as expected #}
gerrit_try_login_{{ account_name }}:
  cmd.run:
    - name: http_proxy='' curl -fsvr -X POST --data "username={{ account_name }}&password={{ account.http_password }}" {{ client.server.protocol|default('http') }}://{{ client.server.host }}:{{ client.server.http_port|default(80) }}{{ client.server.get('url_prefix', '') }}/login
    - check_cmd:
      - /bin/true
{%- endif %}

gerrit_client_account_{{ account_name }}:
  gerrit.account_present:
  - name: {{ account_name }}
  {%- if account.fullname is defined %}
  - fullname: {{ account.fullname }}
  {%- endif %}
  - active: {{ account.get('active', True) }}
  {%- if account.email is defined %}
  - email: {{ account.email }}
  {%- endif %}
  {%- if account.http_password is defined %}
  - http_password: {{ account.http_password }}
  {%- endif %}
  {%- if account.ssh_key is defined %}
  - ssh_key: {{ account.ssh_key }}
  {%- endif %}
  {%- if account.groups is defined %}
  - groups:
    {%- for group in account.groups %}
    - {{ group }}
    {% endfor %}
  {%- endif %}

{%- endfor %}

{%- endif %}
